/* Code used for testing mcucC
 *
 * Copyright (C) 2013 Andreas Misje
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include "mcuc.h"
#ifdef MCUC_slave
#include <stdbool.h>

#include <stdio.h>

union packet mcuc_makeStatusPacket()
{
   //FIXME:
   union packet p = { .p32Status = { .otherUpdate = true } };
   p.type = PackType_status;
   puts( "Making status" );

   return p;
}

int mcuc_handleReceivedPacket( int packetType, uint16_t *packetData,
      uint32_t packetLen )
{
   printf( "Received packet of type %d, %u long:\n", packetType, packetLen );
   uint32_t i;
   for ( i = 0; i < packetLen; ++i )
      printf( "%u ", packetData[ i ] );
   puts( "" );

   return 0;
}

void mcuc_handleError( struct errorInfo error )
{
   printf( "Received an error packet with error %d, abort: %d\n",
         error.error, error.abort );
}

void mcuc_handleStatus( union packet packet )
{
   printf( "Received status: : %d\n", packet.p24Status.RESERVED );
}

void mcuc_prepareQueryResponse( int packetType, uint16_t *packetData,
      uint32_t packetLen )
{
   printf( "Preparing a response for request of type %d\n", packetType );

   if ( packetType == Type_name )
   {
      uint16_t fjas[] = { 0,1,2,3,4,5,6,7,8,9,10,11,12,13};

      union packet *p = (union packet *)&fjas[ 0 ];
      p->type = PackType_header;
      p->header.type = Type_name;
      p->header.query = false;
      p->header.length = 13;

      mcuc_sendPacket( (union packet *)fjas );
   }
   else if ( packetType == Type_poke )
   {
      printf( "Poke (%u) [0]: %u\n", packetLen, packetData[ 0 ] );
      union packet p[ 2 ] = { { .header = {
         .type = Type_poke,
         .length = 1,
      } }, { .data = packetData[ 0 ] + 1 } };
      p[ 0 ].type = PackType_header;

      mcuc_sendPacket( p );
   }
}

#endif // MCUC_slave
