/* 
 * Copyright (C) 2013 Andreas Misje
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include "spi.h"

void spi_init()
{
#if defined __PIC24F__
   PPSUnLock;
   PPSInput( PPS_SDI1, PPS_RP6 );
   PPSOutput( PPS_RP2, PPS_SDO1 );
   PPSOutput( PPS_RP16, PPS_SCK1OUT );
   PPSLock;

   SPI1CON1 = ENABLE_SCK_PIN | ENABLE_SDO_PIN | SPI_MODE16_ON |
      MASTER_ENABLE_ON | SEC_PRESCAL_2_1 | PRI_PRESCAL_1_1;
   SPI1STATbits.SPIROV = 0;
   SPI1STATbits.SPIEN = 1;
   (void)SPI1BUF;

#elif defined __PIC32MX__
   SpiChnOpen( 3, SPI_OPEN_SLVEN | SPI_OPEN_MODE16 | SPI_OPEN_ON, SpiBrgVal(
            GetPeripheralClock(), 8000000u ) );
#endif
}
