/* 
 * Copyright (C) 2013 Andreas Misje
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include "GOLSchemes.h"
#include "Graphics/GOL.h"
#include "externalResources.h"

const GOL_SCHEME defaultGOLScheme =
{
   /* EmbossDkColor: dark emboss: */
   RGBConvert( 41, 41, 41 ),
   /* EmbossLtColor: light emboss: */
   RGBConvert( 110, 110, 110 ),
   /* TextColor0: */
   RGBConvert( 224, 224, 224 ),
   /* TextColor1: */
   RGBConvert( 255, 255, 255 ),
   /* TextColorDisabled: */
   RGBConvert( 80, 80, 80 ),
   /* Color0: */
   RGBConvert( 64, 64, 64 ),
   /* Color1: */
   RGBConvert( 0, 196, 255 ),
   /* ColorDisabled: */
   RGBConvert( 50, 50, 50 ),
   /* CommonBkColor: */
   RGBConvert( 15, 15, 15 ),
   (void *)&FONTDEFAULT,

#ifdef USE_GRADIENT
   {
      GRAD_NONE,                     // Gradient type
      RGBConvert(0xA9, 0xDB, 0xEF),  // Starting color
      RGBConvert(0x26, 0xC7, 0xF2),  // Ending color
      50                             // percentage of the object length
   }
#endif
};

GOL_SCHEME *normalButtonScheme() {
   static GOL_SCHEME *_normalButtonScheme = NULL;

   if ( !_normalButtonScheme ) {
      _normalButtonScheme = GOLCreateScheme();
      _normalButtonScheme->pFont = (void *)&DejaVu_Sans_12;
   }

   return _normalButtonScheme;
}

GOL_SCHEME *statusBarScheme() {
   static GOL_SCHEME *_statusBarScheme = NULL;

   if ( !_statusBarScheme ) {
      _statusBarScheme = GOLCreateScheme();
      _statusBarScheme->pFont = (void *)&DejaVu_Sans_12;
      _statusBarScheme->CommonBkColor = RGBConvert( 0, 44, 56 );
   }

   return _statusBarScheme;
}
