/* 
 * Copyright (C) 2013 Andreas Misje
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * \file
 * \brief Graphics library (part of Microchip application libraries)
 * configuration file
 *
 * \author Andreas Misje
 * \date 21.02.13
 */

#ifndef GRAPHICSCONFIG_H
#define GRAPHICSCONFIG_H

#define USE_NONBLOCKING_CONFIG

#define USE_TOUCHSCREEN

#define USE_GOL
#define USE_BUTTON
#define USE_BUTTON_MULTI_LINE
//#define USE_WINDOW
//#define USE_CHECKBOX
//#define USE_RADIOBUTTON
#define USE_EDITBOX
//#define USE_LISTBOX
//#define USE_SLIDER
//#define USE_PROGRESSBAR
#define USE_STATICTEXT
//#define USE_PICTURE
//#define USE_GROUPBOX
//#define USE_ROUNDDIAL
//#define USE_METER
//#define USE_DIGITALMETER
//#define USE_TEXTENTRY
//#define USE_CUSTOM
//#define USE_GRADIENT

#define USE_MULTIBYTECHAR
//#define USE_UNSIGNED_XCHAR

#define GFX_SCHEMEDEFAULT defaultGOLScheme
#define FONTDEFAULT DejaVu_Sans_12

#define USE_FONT_FLASH
//#define USE_BITMAP_FLASH
//#define USE_FONT_EXTERNAL
//#define USE_BITMAP_EXTERNAL

#define GFX_malloc( size )                   malloc( size )
#define GFX_free( pObj )                     free( pObj )

#define COLOR_DEPTH                          16

#define USE_DOUBLE_BUFFERING

#endif // GRAPHICSCONFIG_H
