/* 
 * Copyright (C) 2013 Andreas Misje
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PICCONFIG_H
#define PICCONFIG_H

#include <p24FJ256DA210.h>

_CONFIG1 (
      JTAGEN_OFF &   // Disable JTAG port
      FWDTEN_OFF &   // Disable watchdog
      GWRP_OFF &     // Disable code flash protection
      GCP_OFF        // Disable program memory protection
      );

_CONFIG2 (
      POSCMOD_XT &   // Use crystal
      IOL1WAY_OFF &  // IOCLOCK can be altered
      OSCIOFNC_OFF & // Use oscillator pins as I/O
      FCKSM_CSDCMD & // Clock switching and fail-safe clock monitor disabled
      FNOSC_PRIPLL & // Primary oscillator with postscaler and PLL
      PLLDIV_DIV2 &  // Configure to 8 MHz input
      IESO_OFF &     // No two-speed start-up
      PLL96MHZ_ON    // ENable 96 MHz PLL
      );

_CONFIG3 (
      SOSCSEL_EC     // SOSC used for external clock
      );

#endif // PICCONFIG_H
