/* 
 * Copyright (C) 2013 Andreas Misje
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _KEYBOARD_H
#define _KEYBOARD_H

#include <GenericTypeDefs.h>
#include <stdbool.h>
#include <Graphics/Graphics.h>

#define MAX_EDIT_FIELD_LINES 6

#define BACKSPACE_DEL_WORD_HOLD_DELAY 700
#define BACKSPACE_DEL_NEXT_WORD_DELAY 250
#define BACKSPACE_DEL_EVERYTHING_HOLD_DELAY 2000
#define KEY_SPECIAL_FUNC_HOLD_DELAY 500

void keyboard_init( int bufferSize, XCHAR *text );

void keyboard_destroy();

WORD keyboard_msgCallback( WORD message, OBJ_HEADER *currentObject,
      GOL_MSG *rawMessage );

bool keyboard_editingFinished();

#endif // _KEYBOARD_H
