/* 
 * Copyright (C) 2013 Andreas Misje
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include "wstring.h"

size_t wstrlen( const XCHAR * str )
{
   size_t len;
   
   if ( !str )
      return 0;

   for ( len = 0; str[ len ]; ++len );

   return len;
}

void wstrncpy( XCHAR * dst, const XCHAR *src, size_t max )
{
   size_t ch;

   for ( ch = 0; ch < max && src[ ch ]; ++ch )
      dst[ ch ] = src[ ch ];

   dst[ ch ] = L'\0';
}
