/* 
 * Copyright (C) 2013 Andreas Misje
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PICCONFIG_H
#define PICCONFIG_H

#pragma config IESO     = OFF       // Internal/external switch-over
#pragma config FNOSC    = PRIPLL    // Oscillator selection
#pragma config FPLLIDIV = DIV_2     // PLL input divider
#pragma config FPLLMUL  = MUL_20    // PLL multiplier
#pragma config FPLLODIV = DIV_1     // PLL output divider
#pragma config FPBDIV   = DIV_1     // Peripheral clock divisor
#pragma config FWDTEN   = OFF       // Watchdog timer
#pragma config WDTPS    = PS1       // Watchdog timer postscaler
#pragma config FCKSM    = CSDCMD    // Clock switching & fail safe clock mon.
#pragma config OSCIOFNC = OFF       // CLKO enable
#pragma config POSCMOD  = XT        // Primary oscillator
#pragma config FSOSCEN  = ON        // Secondary oscillator enable
#pragma config CP       = OFF       // Code protect
#pragma config BWP      = OFF       // Boot flash write protect
#pragma config PWP      = OFF       // Program flash write protect
#pragma config ICESEL   = ICS_PGx2  // ICE/ICD comm channel select
#pragma config DEBUG    = OFF       // Debugger
#pragma config FMIIEN   = OFF       // Enable MII (instead of RMII)
#pragma config FETHIO   = ON        // Use alternate Ethernet I/O

#endif // PICCONFIG_H
