#include "fsUtils.h"
#include <string.h>
#include <stdio.h>
#include "../TCPIPConfig.h"

//static int findSlash( const char *fileName );
//
//int find( const char searchDir[], const char fileName[], bool searchSubDirs,
//      BYTE *fileAttr ) {
//   DIR dir;
//   int slashPos = findSlash( fileName );
//
//#ifdef FATFS_DEBUG
//   printf( "Looking for '%s' in '%s'\n", fileName, searchDir );
//#endif
//
//   FRESULT res = f_opendir( &dir, searchDir );
//   if ( res != FR_OK )
//      return res;
//
//   for (;;) {
//      FILINFO fileInfo;
//#ifdef _USE_LFN
//      char lfnameBuffer[ _MAX_LFN + 1 ];
//      fileInfo.lfname = (char *)&lfnameBuffer;
//      fileInfo.lfsize = sizeof( lfnameBuffer );
//#endif
//      res = f_readdir( &dir, &fileInfo );
//      if ( res != FR_OK )
//         return res;
//      
//      /* All items in directory has been read. Exit: */
//      if ( !fileInfo.fname[ 0 ] ) {
//#ifdef FATFS_DEBUG
//         puts( "But didn't find it" );
//#endif
//         return FIND_NOT_FOUND;
//      }
//
//      /* Ignore '.' and '..': */
//      if ( fileInfo.fname[ 0 ] == '.' )
//         continue;
//
//#ifdef _USE_LFN
//      char *name = *fileInfo.lfname ? fileInfo.lfname : fileInfo.fname;
//#else
//      char *name = fno.fname;
//#endif
//
//      if ( fileInfo.fattrib & AM_DIR ) {
//
//         if ( slashPos != -1 && !strncmp( fileName, name, slashPos ) ) {
//            //puts( "Found subdir!" );
//            char *dirName = malloc( slashPos + 1 );
//            if ( !dirName )
//               return FIND_ERR_MALLOC;
//            *dirName = '\0';
//            strncat( dirName, fileName, slashPos - 1 );
//            dirName[ slashPos ] = '\0';
//            int retVal = find( dirName, &fileName[ slashPos + 1 ],
//                  searchSubDirs, fileAttr );
//            free( dirName );
//
//            if ( retVal == FIND_FOUND )
//               return FIND_FOUND;
//         }
//         else if ( searchSubDirs ) {
//            int retVal = find( name, fileName, searchSubDirs, fileAttr );
//
//            if ( retVal == FIND_FOUND )
//               return FIND_FOUND;
//         }
//      }
//
//      if ( !strcmp( fileName, name ) ) {
//
//         /* If fileName should be a directory, keep on searching: */
//         if ( fileAttr && *fileAttr & AM_DIR && !( fileInfo.fattrib &
//                  AM_DIR ) )
//            continue;
//
//         if ( fileAttr )
//            *fileAttr = fileInfo.fattrib;
//
//         return FIND_FOUND;
//      }
//   }
//
//#ifdef FATFS_DEBUG
//   puts( "But did not find it" );
//#endif
//   return FIND_NOT_FOUND;
//}

char *readStringFromFile( FIL *file )
{
   unsigned int readOK;
   FRESULT retVal;
   size_t i = 0;
   size_t capacity = READSTR_INTIAL_CAPACITY;
   char *string = malloc( capacity * sizeof( char ) );
   if ( !string )
      return NULL;

   for ( ;; )
   {
      retVal = f_read( file, &string[ i ], 1, &readOK );
      /* Read errror or reached end of file: */
      if ( retVal != FR_OK || !readOK )
         break; 

      /* End of string: */
      if ( string[ i ] == '\0' )
         break;

      ++i;

      /* Allocated memory not enough. Increase: */
      if ( i >= capacity )
      {
         char *temp = realloc( string, capacity + READSTR_ALLOC_STEP *
               sizeof( char ) );
         if ( !temp )
         {
            free( string );
            return NULL;
         }
         capacity += READSTR_ALLOC_STEP * sizeof( char );
         string = temp;
      }
   }

   /* If a read failed: */
   if ( retVal != FR_OK || ( !readOK && string[ i ] != '\0' ) )
   {
      free( string );
      return NULL;
   }

   /* Resize string, freeing any unused memory to heap (this is an embedded
    * system, no memory to waste!): */
   char *temp = realloc( string, ( i + 1 ) * sizeof( char ) );
   if ( !temp )
   {
      free( string );
      return NULL;
   }

   return temp;
}


//static int findSlash( const char *fileName ) {
//   int position;
//
//   for ( position = 0; fileName[ position ] != '\0'; ++position )
//      if ( fileName[ position ] == '/' )
//         return position;
//
//   return -1;
//}
