#ifndef FSUTILS_H
#define FSUTILS_H

#include <stdbool.h>
#include "ff.h"

//enum find_returnValues {
//   FIND_ERR_MALLOC = -2,
//   FIND_NOT_FOUND = -1,
//   FIND_FOUND,
//   /* Remaining return values are FRESULT error definitions */
//};
//
//
///**
// * \brief Look for a file or a directory in a directory
// *
// * This function looks for a file or a directory in the given directory,
// * optionally searching sub directories. This function utilises recursion, and
// * should be used with care in deep file systems. If fileAttr is non-NULL, the
// * file's paramters will be stored if the file was found. In order to search
// * for directories, fileAttr must be non-NULL and contain AM_DIR when passed
// * to the function.
// *
// * \param searchDir the directory to search in
// * \param fileName the name of the file or directory to search for
// * \param searchSubDirs if true, search sub directories
// * \param fileAttr pointer to a byte, which if non-NULL will be filled with
// * the found file's attributes
// *
// * \return FIND_NOT_FOUND, FIND_FOUND or any of the defined FRESULT error
// * values
// */
//int find( const char searchDir[], const char fileName[], bool searchSubDirs,
//BYTE *fileAttr );

/**
 * \brief Initial number of characters the dynamic string in
 * readStringFromFile() should hold
 */
#define READSTR_INTIAL_CAPACITY 30

/**
 * \brief The number of bytes by which the dynamic string in
 * readStringFromFile() should increase
 */
#define READSTR_ALLOC_STEP 20

/**
 * \brief Read a string from file, storing the string on the heap
 *
 * This function reads from the given file character-by-character until either
 * EOF or a null byte is reached. The returned string is allocated on the heap
 * (and needs to be freed, which is the responsibility of the caller). The
 * intial capacity of the string is determined by #READSTR_INTIAL_CAPACITY,
 * and the value the capacity should increase by is determined by
 * #READSTR_ALLOC_STEP. When the reading is completed, a re-allocation is
 * performed, so that the allocated memory equals the size of the string.
 *
 * \param file the file to read from
 *
 * \return the string, or NULL if either memory allocation fails or if a read
 * operation fails
 */
char *readStringFromFile( FIL *file );

#endif // FSUTILS_H
