/*
 * Set and retrieve name and title from file
 *
 * Copyright (C) 2013 Andreas Misje
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include "form.h"
#include <stdio.h>
#include "TCPIPConfig.h"

HTTP_IO_RESULT HTTPExecuteGet()
{
   return HTTP_IO_DONE;
}

HTTP_IO_RESULT HTTPExecutePost()
{
   switch ( curHTTP.POSTFileID )
   {
      case POSTFileName_network:
         return form_handleNetworkSettingsPOST();

      case POSTFileName_time:
         return form_handleTimeSettingsPOST();

      case POSTFileName_availType:
         return form_handleAvailTypePOST();

      case POSTFileName_bio:
         return form_handleBioPOST();

      default:
         printf( "%s at %u: ERROR: Invalid POST file ID: %u\n", __func__,
               __LINE__, curHTTP.POSTFileID );
         return HTTP_IO_DONE ;
   }
}
